CREATE SEQUENCE cust_auth_seq
  START WITH 1
  MAXVALUE 9999999999
  NOCACHE;
CREATE TABLE cust_auth_users
(  usr_id                    NUMBER              NOT NULL,
  usr_name                  VARCHAR2(50),
  usr_first_name            VARCHAR2(50),
  usr_last_name             VARCHAR2(50),
  usr_email                 VARCHAR2(100),
  usr_password_hash         VARCHAR2(100),
  usr_valid_from            DATE,
  usr_valid_to              DATE,
  usr_password_valid_until  DATE,
  usr_description           VARCHAR2(4000)
);
CREATE OR REPLACE TRIGGER cust_auth_users_bi_trg
   BEFORE INSERT ON cust_auth_users
   REFERENCING NEW AS NEW OLD AS OLD
   FOR EACH ROW
BEGIN
   IF :NEW.usr_id IS NULL
   THEN
      SELECT cust_auth_seq.NEXTVAL
        INTO :NEW.usr_id
        FROM DUAL;
   END IF;
END;
/
ALTER TABLE cust_auth_users ADD (
  CONSTRAINT cust_auth_users_pk
 PRIMARY KEY
 (usr_id));
ALTER TABLE cust_auth_users ADD (
  CONSTRAINT cust_auth_users_uc
 UNIQUE (usr_name));
