CREATE OR REPLACE VIEW emp_no_primary_key_v
AS
   SELECT ROWID primary_key, ename, job, sal
     FROM emp;
/
CREATE OR REPLACE TRIGGER io_upd_emp_no_primary_key_v_tr
   INSTEAD OF UPDATE
   ON emp_no_primary_key_v
   REFERENCING NEW AS NEW OLD AS OLD
   FOR EACH ROW
BEGIN
   UPDATE emp_no_primary_key_v
      SET ename = :NEW.ename,
          job = :NEW.job,
          sal = :NEW.sal
    WHERE ROWID = :NEW.primary_key;
END;
/ 
CREATE OR REPLACE TRIGGER io_ins_emp_no_primary_key_v_tr
   INSTEAD OF INSERT
   ON emp_no_primary_key_v
   REFERENCING NEW AS NEW OLD AS OLD
   FOR EACH ROW
BEGIN
   INSERT INTO emp_no_primary_key_v
               (ename, job, sal
               )
        VALUES (:NEW.ename, :NEW.job, :NEW.sal
               );
END;
/
