/*

!!! Dieses Beispiel weicht vom Buch ab !!!

Im Buch wird utl_http.read_line() verwendet, dies ist den offiziellen Beispielen von Oracle
entnommen. 

Leider werden heutzutage oft keine Newlines in den HTML Seiten mehr verwendet, um den 
Code kompakter zu halten und das Rendering im Browser zu beschleunigen. 

Der Befehl read_line() liest jedoch soweit, bis ein Newline gefunden wird und max. 
knnen dies als Varchar2 32767 Zeichen sein. 

Daher ist der Befehl read_text() hier besser geeignet, da wir dabei angeben knnen, wie 
viele Zeichen auf einmal gelesen werden sollen.

Fr Oracle bis Version 10 muss dem Benutzer noch das Grant fr die Ausfhrung des 
Paketes utl_http erteilt werden. 

Bsp. : Dem Oracle Benutzer APEX_XE_PRAXIS das Recht erteilen: 
Als SYS: 
>grant execute on sys.utl_http to APEX_XE_PRAXIS; 

*/


SET serveroutput ON SIZE 1000000

DECLARE
  req   utl_http.req;
  resp  utl_http.resp;
  value VARCHAR2(100);
BEGIN
  --utl_http.set_proxy('proxy.my-company.com', 'corp.my-company.com');
  req := utl_http.begin_request(
              'http://daust.blogspot.com/feeds/posts/default?alt=rss');
  utl_http.set_header(req, 'User-Agent', 'Mozilla/4.0');
  resp := utl_http.get_response(req);
  LOOP
    utl_http.read_text(r => resp, data => value, len => 100);
    dbms_output.put_line(value);
  END LOOP;
  utl_http.end_response(resp);
EXCEPTION
  WHEN utl_http.end_of_body THEN
    utl_http.end_response(resp);
END;
/

